Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 859)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 861)
@@ -320,237 +286,245 @@
        CHARACTER (LEN = *), INTENT(IN)    :: sk_char
 
-
-       degraded_l = .FALSE.
-       degraded_s = .FALSE.
-
-       IF ( boundary_flags(j,i) /= 0 )  THEN
-!       
-!--       Degrade the order for Dirichlet bc. at the outflow boundary
-          SELECT CASE ( boundary_flags(j,i) )
-
-             CASE ( 1 )
-
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   u_comp    = u(k,j,i+1) - u_gtrans
-                   flux_r(k) = u_comp * (                                      &
-                               7.0 * ( sk(k,j,i+1) + sk(k,j,i)   )             &
-                                   - ( sk(k,j,i+2) + sk(k,j,i-1) ) ) * adv_sca_3
-                   diss_r(k) = -ABS( u_comp ) * (                              &
-                               3.0 * ( sk(k,j,i+1) - sk(k,j,i)   )             &
-                                   - ( sk(k,j,i+2) - sk(k,j,i-1) ) ) * adv_sca_3
-                ENDDO
-
-             CASE ( 2 )
-
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   u_comp    = u(k,j,i+1) - u_gtrans
-                   flux_r(k) = u_comp * ( sk(k,j,i+1) + sk(k,j,i) ) * 0.5
-                   diss_r(k) = diss_2nd( sk(k,j,i+1), sk(k,j,i+1), sk(k,j,i),  &
-                                         sk(k,j,i-1), sk(k,j,i-2), u_comp,     &
-                                         0.5, ddx )
-                ENDDO
-
-             CASE ( 3 )
-
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   v_comp = v(k,j+1,i) - v_gtrans
-                   flux_n(k) = v_comp * (                                      &
-                               7.0 * ( sk(k,j+1,i) + sk(k,j,i)   )             &
-                                   - ( sk(k,j+2,i) + sk(k,j-1,i) ) ) * adv_sca_3
-                   diss_n(k) = -ABS( v_comp ) * (                              &
-                               3.0 * ( sk(k,j+1,i) - sk(k,j,i)     )           &
-                                   - ( sk(k,j+2,i) - sk(k,j-1,i) ) ) * adv_sca_3
-               ENDDO
-
-             CASE ( 4 )
-
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   v_comp    = v(k,j+1,i) - v_gtrans
-                   flux_n(k) = v_comp* ( sk(k,j+1,i) + sk(k,j,i) ) * 0.5
-                   diss_n(k) = diss_2nd( sk(k,j+1,i), sk(k,j+1,i), sk(k,j,i), &
-                                         sk(k,j-1,i), sk(k,j-2,i), v_comp,    &
-                                         0.5, ddy )     
-                ENDDO
-
-             CASE ( 5 )
-
-                DO  k = nzb_w_inner(j,i)+1, nzt
-                   u_comp    = u(k,j,i+1) - u_gtrans 
-                   flux_r(k) = u_comp  * (                                     &
-                               7.0 * ( sk(k,j,i+1) + sk(k,j,i)   )             &
-                                   - ( sk(k,j,i+2) + sk(k,j,i-1) ) ) * adv_sca_3
-                   diss_r(k) = -ABS( u_comp ) * (                              &
-                               3.0 * ( sk(k,j,i+1) - sk(k,j,i)   )             &
-                                   - ( sk(k,j,i+2) - sk(k,j,i-1) ) ) * adv_sca_3
-                ENDDO  
-
-             CASE ( 6 )
-
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   u_comp    = u(k,j,i+1) - u_gtrans
-                   flux_r(k) = u_comp * (                                      &
-                               7.0 * ( sk(k,j,i+1) + sk(k,j,i)   )             &
-                                   - ( sk(k,j,i+2) + sk(k,j,i-1) ) ) * adv_sca_3
-                   diss_r(k) = -ABS( u_comp ) * (                              &
-                               3.0 * ( sk(k,j,i+1) - sk(k,j,i)   )             &
-                                   - ( sk(k,j,i+2) - sk(k,j,i-1) ) ) * adv_sca_3
-!                              
-!--                Compute leftside fluxes for the left boundary of PE domain
-                   u_comp                 = u(k,j,i) - u_gtrans
-                   swap_flux_x_local(k,j,tn) = u_comp * (                         &
-                                            sk(k,j,i) + sk(k,j,i-1) ) * 0.5
-                   swap_diss_x_local(k,j,tn) = diss_2nd( sk(k,j,i+2),sk(k,j,i+1), &
-                                                      sk(k,j,i), sk(k,j,i-1),  &
-                                                      sk(k,j,i-1), u_comp,     &
-                                                      0.5, ddx ) 
-                ENDDO
-                degraded_l = .TRUE.
-
-             CASE ( 7 )
-
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   v_comp    = v(k,j+1,i)-v_gtrans
-                   flux_n(k) = v_comp * (                                      &
-                               7.0 * ( sk(k,j+1,i) + sk(k,j,i)   )             &
-                                   - ( sk(k,j+2,i) + sk(k,j-1,i) ) ) * adv_sca_3
-                   diss_n(k) = -ABS( v_comp ) * (                              &
-                               3.0 * ( sk(k,j+1,i) - sk(k,j,i)   )             &
-                                   - ( sk(k,j+2,i) - sk(k,j-1,i) ) ) * adv_sca_3
-                ENDDO
-
-             CASE ( 8 )
-
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   v_comp    = v(k,j+1,i) - v_gtrans 
-                   flux_n(k) = v_comp * (                                      &
-                               7.0 * ( sk(k,j+1,i) + sk(k,j,i)   )             &
-                                   - ( sk(k,j+2,i) + sk(k,j-1,i) ) ) * adv_sca_3
-                   diss_n(k) = -ABS( v_comp ) * (                              &
-                               3.0 * ( sk(k,j+1,i) - sk(k,j,i)   )             &
-                                   - ( sk(k,j+2,i) - sk(k,j-1,i) ) ) * adv_sca_3
-!                              
-!--                Compute southside fluxes for the south boundary of PE domain
-                   v_comp               = v(k,j,i) - v_gtrans
-                   swap_flux_y_local(k,tn) = v_comp *                             &
-                                          ( sk(k,j,i) + sk(k,j-1,i) ) * 0.5 
-                   swap_diss_y_local(k,tn) = diss_2nd( sk(k,j+2,i), sk(k,j+1,i),  &
-                                                    sk(k,j,i), sk(k,j-1,i),    &
-                                                    sk(k,j-1,i), v_comp,       &
-                                                    0.5, ddy )
-                ENDDO
-                degraded_s = .TRUE.
-               
-             CASE DEFAULT
-            
-          END SELECT
-
-!         
-!--       Compute the crosswise 5th order fluxes at the outflow
-          IF ( boundary_flags(j,i) == 1  .OR.  boundary_flags(j,i) == 2  .OR. &
-               boundary_flags(j,i) == 5  .OR.  boundary_flags(j,i) == 6 )  THEN
-
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                v_comp    = v(k,j+1,i) - v_gtrans
-                flux_n(k) = v_comp * (                                         &
-                            37.0 * ( sk(k,j+1,i) + sk(k,j,i)   )               &
-                          -  8.0 * ( sk(k,j+2,i) + sk(k,j-1,i) )               &
-                          +        ( sk(k,j+3,i) + sk(k,j-2,i) ) ) * adv_sca_5
-                diss_n(k) = -ABS( v_comp ) * (                                 &
-                            10.0 * ( sk(k,j+1,i) - sk(k,j,i)   )               &
-                          -  5.0 * ( sk(k,j+2,i) - sk(k,j-1,i) )               &
-                          +        ( sk(k,j+3,i) - sk(k,j-2,i) ) ) * adv_sca_5
-             ENDDO
-            
-          ELSE
-         
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                u_comp    = u(k,j,i+1) - u_gtrans  
-                flux_r(k) = u_comp * (                                         &
-                            37.0 * ( sk(k,j,i+1) + sk(k,j,i)   )               &
-                          -  8.0 * ( sk(k,j,i+2) + sk(k,j,i-1) )               &
-                          +        ( sk(k,j,i+3) + sk(k,j,i-2) ) ) * adv_sca_5
-                diss_r(k) = -ABS( u_comp ) * (                                 &
-                            10.0 * ( sk(k,j,i+1) - sk(k,j,i)   )               &
-                          -  5.0 * ( sk(k,j,i+2) - sk(k,j,i-1) )               &
-                          +        ( sk(k,j,i+3) - sk(k,j,i-2) ) ) * adv_sca_5
-             ENDDO
-            
-          ENDIF
-
-       ELSE
-               
-!
-!--       Compute the fifth order fluxes for the interior of PE domain.
-          DO  k = nzb_u_inner(j,i)+1, nzt
-             u_comp    = u(k,j,i+1) - u_gtrans
-             flux_r(k) = u_comp * (                                           &
-                         37.0 * ( sk(k,j,i+1) + sk(k,j,i)   )                 &
-                       -  8.0 * ( sk(k,j,i+2) + sk(k,j,i-1) )                 &
-                       +        ( sk(k,j,i+3) + sk(k,j,i-2) ) ) * adv_sca_5
-             diss_r(k) = -ABS( u_comp ) * (                                   &
-                         10.0 * ( sk(k,j,i+1) - sk(k,j,i)   )                 &
-                       -  5.0 * ( sk(k,j,i+2) - sk(k,j,i-1) )                 &
-                       +        ( sk(k,j,i+3) - sk(k,j,i-2) ) ) * adv_sca_5
-
-             v_comp    = v(k,j+1,i) - v_gtrans
-             flux_n(k) = v_comp * (                                           &
-                         37.0 * ( sk(k,j+1,i) + sk(k,j,i)   )                 &
-                       -  8.0 * ( sk(k,j+2,i) + sk(k,j-1,i) )                 &
-                       +        ( sk(k,j+3,i) + sk(k,j-2,i) ) ) * adv_sca_5
-             diss_n(k) = -ABS( v_comp ) * (                                   &
-                         10.0 * ( sk(k,j+1,i) - sk(k,j,i)   )                 &
-                       -  5.0 * ( sk(k,j+2,i) - sk(k,j-1,i) )                 &
-                       +        ( sk(k,j+3,i) - sk(k,j-2,i) ) ) * adv_sca_5
-          ENDDO
-          
+!
+!--    Compute southside fluxes of the respective PE bounds.
+       IF ( j == nys )  THEN
+!
+!--       Up to the top of the highest topography.
+          DO  k = nzb+1, nzb_max
+
+             v_comp                  = v(k,j,i) - v_gtrans
+             swap_flux_y_local(k,tn) = v_comp * (                             &
+                         ( 37.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                      +     7.0 * IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3  &
+                      +           IBITS(wall_flags_0(k,j,i),3,1) * adv_sca_1  &
+                         ) *                                                  &
+                                     ( sk(k,j,i)  + sk(k,j-1,i)     )         &
+                  -      (  8.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                      +           IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3  &
+                         ) *                                                  &
+                                     ( sk(k,j+1,i) + sk(k,j-2,i)    )         &
+                  +      (        IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                         ) *                                                  &
+                                     ( sk(k,j+2,i) + sk(k,j-3,i)    )         &
+                                                )
+
+             swap_diss_y_local(k,tn) = -ABS( v_comp ) * (                     &
+                         ( 10.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                      +     3.0 * IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3  &
+                      +           IBITS(wall_flags_0(k,j,i),3,1) * adv_sca_1  &
+                         ) *                                                  &
+                                     ( sk(k,j,i)   - sk(k,j-1,i)    )         &
+                  -      (  5.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                      +           IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3  &
+                         ) *                                                  &
+                                     ( sk(k,j+1,i) - sk(k,j-2,i)  )           &
+                  +      (        IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                         ) *                                                  &
+                                     ( sk(k,j+2,i) - sk(k,j-3,i) )            &
+                                                        )
+
+          ENDDO
+!
+!--       Above to the top of the highest topography. No degradation necessary.
+          DO  k = nzb_max+1, nzt
+
+             v_comp               = v(k,j,i) - v_gtrans
+             swap_flux_y_local(k,tn) = v_comp * (                            &
+                                    37.0 * ( sk(k,j,i)   + sk(k,j-1,i) )     &
+                                  -  8.0 * ( sk(k,j+1,i) + sk(k,j-2,i) )     &
+                                  +        ( sk(k,j+2,i) + sk(k,j-3,i) )     &
+                                             ) * adv_sca_5
+              swap_diss_y_local(k,tn) = -ABS( v_comp ) * (                   &
+                                    10.0 * ( sk(k,j,i)   - sk(k,j-1,i) )     &
+                                  -  5.0 * ( sk(k,j+1,i) - sk(k,j-2,i) )     &
+                                  +          sk(k,j+2,i) - sk(k,j-3,i)       &
+                                                        ) * adv_sca_5
+
+          ENDDO
+
        ENDIF
-!       
-!--    Compute left- and southside fluxes of the respective PE bounds.        
-       IF ( j == nys  .AND.  .NOT. degraded_s )  THEN
-       
-           DO  k = nzb_s_inner(j,i)+1, nzt
-              v_comp               = v(k,j,i) - v_gtrans
-              swap_flux_y_local(k,tn) = v_comp * (                               &
-                                     37.0 * ( sk(k,j,i)   + sk(k,j-1,i) )     &
-                                   -  8.0 * ( sk(k,j+1,i) + sk(k,j-2,i) )     &
-                                   +        ( sk(k,j+2,i) + sk(k,j-3,i) )     &
-                                              ) * adv_sca_5
-              swap_diss_y_local(k,tn) = -ABS( v_comp ) * (                       &
-                                     10.0 * ( sk(k,j,i)   - sk(k,j-1,i) )     &
-                                   -  5.0 * ( sk(k,j+1,i) - sk(k,j-2,i) )     &
-                                   +          sk(k,j+2,i) - sk(k,j-3,i)       &
-                                                      ) * adv_sca_5
-           ENDDO           
-          
-        ENDIF
+!
+!--    Compute leftside fluxes of the respective PE bounds.
+       IF ( i == i_omp )  THEN
         
-        IF ( i == i_omp  .AND.  .NOT. degraded_l )  THEN
-        
-           DO  k = nzb_s_inner(j,i)+1, nzt
-              u_comp                 = u(k,j,i) - u_gtrans
-              swap_flux_x_local(k,j,tn) = u_comp * (                             &
-                                       37.0 * ( sk(k,j,i)   + sk(k,j,i-1) )   &
-                                     -  8.0 * ( sk(k,j,i+1) + sk(k,j,i-2) )   &
-                                     +        ( sk(k,j,i+2) + sk(k,j,i-3) )   &
-                                                ) * adv_sca_5
-              swap_diss_x_local(k,j,tn) = -ABS( u_comp ) * (                     &
-                                       10.0 * ( sk(k,j,i)   - sk(k,j,i-1) )   &
-                                     -  5.0 * ( sk(k,j,i+1) - sk(k,j,i-2) )   &
-                                     +        ( sk(k,j,i+2) - sk(k,j,i-3) )   &
-                                                        ) * adv_sca_5
-           ENDDO
+          DO  k = nzb+1, nzb_max
+
+             u_comp                 = u(k,j,i) - u_gtrans
+             swap_flux_x_local(k,j,tn) = u_comp * (                           &
+                         ( 37.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                      +     7.0 * IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3  &
+                      +           IBITS(wall_flags_0(k,j,i),0,1) * adv_sca_1  &
+                         ) *                                                  &
+                                     ( sk(k,j,i)   + sk(k,j,i-1)    )         &
+                  -      (  8.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                      +           IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3  &
+                         ) *                                                  &
+                                     ( sk(k,j,i+1) + sk(k,j,i-2)    )         &
+                  +      (        IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                         ) *         ( sk(k,j,i+2) + sk(k,j,i-3)    )         &
+                                                  )
+
+              swap_diss_x_local(k,j,tn) = -ABS( u_comp ) * (                  &
+                         ( 10.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                      +     3.0 * IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3  &
+                      +           IBITS(wall_flags_0(k,j,i),0,1) * adv_sca_1  &
+                         ) *                                                  &
+                                     ( sk(k,j,i)   - sk(k,j,i-1)    )         &
+                  -      (  5.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                      +           IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3  &
+                         ) *                                                  &
+                                     ( sk(k,j,i+1) - sk(k,j,i-2)  )           &
+                  +      (        IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                         ) *                                                  &
+                                     ( sk(k,j,i+2) - sk(k,j,i-3) )            &
+                                                           )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             u_comp                 = u(k,j,i) - u_gtrans
+             swap_flux_x_local(k,j,tn) = u_comp * (                          &
+                                      37.0 * ( sk(k,j,i)   + sk(k,j,i-1) )   &
+                                    -  8.0 * ( sk(k,j,i+1) + sk(k,j,i-2) )   &
+                                    +        ( sk(k,j,i+2) + sk(k,j,i-3) )   &
+                                                  ) * adv_sca_5
+
+             swap_diss_x_local(k,j,tn) = -ABS( u_comp ) * (                  &
+                                      10.0 * ( sk(k,j,i)   - sk(k,j,i-1) )   &
+                                    -  5.0 * ( sk(k,j,i+1) - sk(k,j,i-2) )   &
+                                    +        ( sk(k,j,i+2) - sk(k,j,i-3) )   &
+                                                          ) * adv_sca_5
+
+          ENDDO
            
-        ENDIF
-
+       ENDIF
+
+       flux_t(0) = 0.0
+       diss_t(0) = 0.0
+       flux_d    = 0.0
+       diss_d    = 0.0
 !        
-!--    Now compute the tendency terms for the horizontal parts
-       DO  k = nzb_s_inner(j,i)+1, nzt
-          
-          tend(k,j,i) = tend(k,j,i) - (                                      &
-                          ( flux_r(k) + diss_r(k) - swap_flux_x_local(k,j,tn) - &
-                            swap_diss_x_local(k,j,tn) ) * ddx                   &
-                        + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k,tn)   - &
-                            swap_diss_y_local(k,tn)   ) * ddy                   &
-                                      )
+!--    Now compute the fluxes and tendency terms for the horizontal and
+!--    vertical parts up to the top of the highest topography.
+       DO  k = nzb+1, nzb_max
+!
+!--       Note: It is faster to conduct all multiplications explicitly, e.g.
+!--       * adv_sca_5 ... than to determine a factor and multiplicate the
+!--       flux at the end. Indeed, per loop the first requires 6
+!--       multiplications more, but the the second requires 9 more internal
+!--       calls of IBITS(). 
+          u_comp    = u(k,j,i+1) - u_gtrans
+          flux_r(k) = u_comp * (                                            &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),0,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k,j,i+1) + sk(k,j,i)   )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k,j,i+2) + sk(k,j,i-1) )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                     ) *     ( sk(k,j,i+3) + sk(k,j,i-2) )                  &
+                               )
+
+          diss_r(k) = -ABS( u_comp ) * (                                    &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),0,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k,j,i+1) - sk(k,j,i)  )                   &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k,j,i+2) - sk(k,j,i-1) )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                     ) *                                                    &
+                             ( sk(k,j,i+3) - sk(k,j,i-2) )                  &
+                                       )
+
+          v_comp    = v(k,j+1,i) - v_gtrans
+          flux_n(k) = v_comp * (                                            &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),3,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k,j+1,i) + sk(k,j,i)   )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k,j+2,i) + sk(k,j-1,i) )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                     ) *                                                    &
+                             ( sk(k,j+3,i) + sk(k,j-2,i) )                  &
+                               )
+
+          diss_n(k) = -ABS( v_comp ) * (                                    &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),3,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k,j+1,i) - sk(k,j,i)    )                 &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k,j+2,i) - sk(k,j-1,i)  )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                     ) *                                                    &
+                             ( sk(k,j+3,i) - sk(k,j-2,i) )                  &
+                                       )
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),8,1)
+          k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),6,1)  )
+          k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),8,1)
+
+
+          flux_t(k) = w(k,j,i) * (                                          &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),6,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k+1,j,i)  + sk(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k_pp,j,i) + sk(k-1,j,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                     ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )                &
+                                 )
+
+          diss_t(k) = -ABS( w(k,j,i) ) * (                                  &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),6,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k+1,j,i)   - sk(k,j,i)    )               &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k_pp,j,i)  - sk(k-1,j,i)  )               &
+              +      (        IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                     ) *                                                    &
+                             ( sk(k_ppp,j,i) - sk(k_mm,j,i) )               &
+                                         )
+!
+!--       Calculate the divergence of the velocity field. A respective
+!--       correction is needed to overcome numerical instabilities caused
+!--       by a not sufficient reduction of divergences near topography. 
+          div         =   ( u(k,j,i+1) - u(k,j,i)   ) * ddx                   &
+                        + ( v(k,j+1,i) - v(k,j,i)   ) * ddy                   &
+                        + ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)
+
+          tend(k,j,i) = tend(k,j,i) - (                                       &
+                        ( flux_r(k) + diss_r(k) - swap_flux_x_local(k,j,tn) - &
+                          swap_diss_x_local(k,j,tn)            ) * ddx        &
+                      + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k,tn)   - &
+                          swap_diss_y_local(k,tn)              ) * ddy        &
+                      + ( flux_t(k) + diss_t(k) - flux_d - diss_d             &
+                                                               ) * ddzw(k)    &
+                                      ) + sk(k,j,i) * div
 
           swap_flux_y_local(k,tn)   = flux_n(k)
